#pragma once

// 1.19.0.0 Hard Disk Status/Indicator Light
#define HD_LED 1

	// Keyboard -- keystroke type
	enum {NOT_ASCII=0, ASCII};

// 3D Border
	#define  VIEWPORTX   5
	#define  VIEWPORTY   5

	// 560 = Double Hi-Res
	// 384 = Doule Scan Line
#if 0	// +CU version
	#define  FRAMEBUFFER_W  560
	#define  FRAMEBUFFER_H  384
#else	// +CU version
	#define  MARGIN_LEFT    14
	#define  MARGIN_RIGHT   14
	#define  MARGIN_TOP     16
	#define  MARGIN_BOTTOM  16
	#define  FRAMEBUFFER_W  (560 + MARGIN_LEFT + MARGIN_RIGHT)
	#define  FRAMEBUFFER_H  (384 + MARGIN_TOP + MARGIN_BOTTOM)
#endif	// +CU version

// Direct Draw -- For Full Screen
	extern	LPDIRECTDRAW        g_pDD;
	extern	LPDIRECTDRAWSURFACE g_pDDPrimarySurface;
	extern	IDirectDrawPalette* g_pDDPal;

// Win32
	extern HWND       g_hFrameWindow;
	extern BOOL       g_bIsFullScreen;
	extern BOOL       g_bMultiMon;

// Emulator
	extern bool   g_bFreshReset;
	extern string PathFilename[2];
	extern bool   g_bScrollLock_FullSpeed;
	extern int    g_nCharsetType;

// Prototypes
	void CtrlReset();

	void    FrameCreateWindow(void);
	HDC     FrameGetDC ();
	HDC     FrameGetVideoDC (LPBYTE *,LONG *);
	void    FrameRefreshStatus (int);
	void    FrameRegisterClass ();
	void    FrameReleaseDC ();
	void    FrameReleaseVideoDC ();
	void	FrameSetCursorPosByMousePos();
	int		GetViewportScale(void);
	void    SetViewportScale(int nNewScale);
	void	GetViewportCXCY(int& nViewportCX, int& nViewportCY);

	LRESULT CALLBACK FrameWndProc (
		HWND   window,
		UINT   message,
		WPARAM wparam,
		LPARAM lparam );

