#pragma once

void    ClipboardInitiatePaste();

void    KeybReset();
bool    KeybGetAltStatus();
bool    KeybGetCapsStatus();
bool    KeybGetP8CapsStatus();
bool    KeybGetCtrlStatus();
bool    KeybGetShiftStatus();
bool    KeybGetCapsAllowed(); //For Pravets8A/C only
void    KeybUpdateCtrlShiftStatus();
BYTE    KeybGetKeycode ();
DWORD   KeybGetNumQueries ();
void    KeybQueueKeypress (int,BOOL);
void    KeybToggleCapsLock ();
void    KeybToggleP8ACapsLock ();
DWORD   KeybGetSnapshot(SS_IO_Keyboard* pSS);
DWORD   KeybSetSnapshot(SS_IO_Keyboard* pSS);

BYTE __stdcall KeybReadData (WORD pc, WORD addr, BYTE bWrite, BYTE d, ULONG nCyclesLeft);
BYTE __stdcall KeybReadFlag (WORD pc, WORD addr, BYTE bWrite, BYTE d, ULONG nCyclesLeft);
BYTE __stdcall KbdAllow8Bit (WORD pc, WORD addr, BYTE bWrite, BYTE d, ULONG nCyclesLeft); //For Pravets A/C only

extern bool g_bShiftKey;
extern bool g_bCtrlKey;
extern bool g_bAltKey;

#if 1	// +CU version
enum arrowkeys_index_e {
	ARROWKEYS_NO_CHANGES = 0,
	ARROWKEYS_AUTO_SELECT,
	ARROWKEYS_INDEX_OFFSET
};

struct arrowkeys_file_list_t {
	struct arrowkeys_file_list_t *next;
	char *name;
	bool is_dir;
};

enum arrowkeys_replacekey_e {
	ARROWKEYS_INDEX_LEFT = 0,
	ARROWKEYS_INDEX_UP,
	ARROWKEYS_INDEX_RIGHT,
	ARROWKEYS_INDEX_DOWN
};

struct arrowkeys_replacekey_t {
	int	key;
	BOOL	is_ascii;
};

struct arrowkeys_list_t {
	struct arrowkeys_list_t *next;
	struct arrowkeys_file_list_t *file;
	char *label;
	struct arrowkeys_replacekey_t replacekeys[4];
};

extern char* KeybGetArrowKeysFilename();
extern void KeybSetArrowKeysFilename(const char *filename);
extern void KeybFreeArrowKeysList(struct arrowkeys_list_t *list);
extern void KeybSetArrowKeysList(struct arrowkeys_list_t *list);
extern int KeybGetArrowKeysIndex();
extern void KeybSetArrowKeysIndex(int index);
extern int KeybLoadArrowKeys();
extern int KeybLoadArrowKeys(struct arrowkeys_list_t * &list, const char *filename);
extern LPTSTR KeybCreateArrowKeysChoices();
extern LPTSTR KeybCreateArrowKeysChoices(const struct arrowkeys_list_t *list);
extern bool KeybArrowKeysIsAutoSelect();
extern bool KeybSelectArrowKeys();
extern bool KeybSelectArrowKeys(const char *filename);
#endif	// +CU version
